part of 'generated.dart';

class GetApplicationByIdVariablesBuilder {
  String id;

  final FirebaseDataConnect _dataConnect;
  GetApplicationByIdVariablesBuilder(this._dataConnect, {required  this.id,});
  Deserializer<GetApplicationByIdData> dataDeserializer = (dynamic json)  => GetApplicationByIdData.fromJson(jsonDecode(json));
  Serializer<GetApplicationByIdVariables> varsSerializer = (GetApplicationByIdVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<GetApplicationByIdData, GetApplicationByIdVariables>> execute() {
    return ref().execute();
  }

  QueryRef<GetApplicationByIdData, GetApplicationByIdVariables> ref() {
    GetApplicationByIdVariables vars= GetApplicationByIdVariables(id: id,);
    return _dataConnect.query("getApplicationById", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class GetApplicationByIdApplication {
  final String id;
  final String shiftId;
  final String staffId;
  final EnumValue<ApplicationStatus> status;
  final Timestamp? appliedAt;
  final Timestamp? checkInTime;
  final Timestamp? checkOutTime;
  final EnumValue<ApplicationOrigin> origin;
  final Timestamp? createdAt;
  final GetApplicationByIdApplicationShift shift;
  final GetApplicationByIdApplicationShiftRole shiftRole;
  GetApplicationByIdApplication.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  shiftId = nativeFromJson<String>(json['shiftId']),
  staffId = nativeFromJson<String>(json['staffId']),
  status = applicationStatusDeserializer(json['status']),
  appliedAt = json['appliedAt'] == null ? null : Timestamp.fromJson(json['appliedAt']),
  checkInTime = json['checkInTime'] == null ? null : Timestamp.fromJson(json['checkInTime']),
  checkOutTime = json['checkOutTime'] == null ? null : Timestamp.fromJson(json['checkOutTime']),
  origin = applicationOriginDeserializer(json['origin']),
  createdAt = json['createdAt'] == null ? null : Timestamp.fromJson(json['createdAt']),
  shift = GetApplicationByIdApplicationShift.fromJson(json['shift']),
  shiftRole = GetApplicationByIdApplicationShiftRole.fromJson(json['shiftRole']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdApplication otherTyped = other as GetApplicationByIdApplication;
    return id == otherTyped.id && 
    shiftId == otherTyped.shiftId && 
    staffId == otherTyped.staffId && 
    status == otherTyped.status && 
    appliedAt == otherTyped.appliedAt && 
    checkInTime == otherTyped.checkInTime && 
    checkOutTime == otherTyped.checkOutTime && 
    origin == otherTyped.origin && 
    createdAt == otherTyped.createdAt && 
    shift == otherTyped.shift && 
    shiftRole == otherTyped.shiftRole;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, shiftId.hashCode, staffId.hashCode, status.hashCode, appliedAt.hashCode, checkInTime.hashCode, checkOutTime.hashCode, origin.hashCode, createdAt.hashCode, shift.hashCode, shiftRole.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['shiftId'] = nativeToJson<String>(shiftId);
    json['staffId'] = nativeToJson<String>(staffId);
    json['status'] = 
    applicationStatusSerializer(status)
    ;
    if (appliedAt != null) {
      json['appliedAt'] = appliedAt!.toJson();
    }
    if (checkInTime != null) {
      json['checkInTime'] = checkInTime!.toJson();
    }
    if (checkOutTime != null) {
      json['checkOutTime'] = checkOutTime!.toJson();
    }
    json['origin'] = 
    applicationOriginSerializer(origin)
    ;
    if (createdAt != null) {
      json['createdAt'] = createdAt!.toJson();
    }
    json['shift'] = shift.toJson();
    json['shiftRole'] = shiftRole.toJson();
    return json;
  }

  GetApplicationByIdApplication({
    required this.id,
    required this.shiftId,
    required this.staffId,
    required this.status,
    this.appliedAt,
    this.checkInTime,
    this.checkOutTime,
    required this.origin,
    this.createdAt,
    required this.shift,
    required this.shiftRole,
  });
}

@immutable
class GetApplicationByIdApplicationShift {
  final String id;
  final String title;
  final Timestamp? date;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final String? location;
  final EnumValue<ShiftStatus>? status;
  final GetApplicationByIdApplicationShiftOrder order;
  GetApplicationByIdApplicationShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  title = nativeFromJson<String>(json['title']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']),
  status = json['status'] == null ? null : shiftStatusDeserializer(json['status']),
  order = GetApplicationByIdApplicationShiftOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdApplicationShift otherTyped = other as GetApplicationByIdApplicationShift;
    return id == otherTyped.id && 
    title == otherTyped.title && 
    date == otherTyped.date && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    location == otherTyped.location && 
    status == otherTyped.status && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, title.hashCode, date.hashCode, startTime.hashCode, endTime.hashCode, location.hashCode, status.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['title'] = nativeToJson<String>(title);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    if (status != null) {
      json['status'] = 
    shiftStatusSerializer(status!)
    ;
    }
    json['order'] = order.toJson();
    return json;
  }

  GetApplicationByIdApplicationShift({
    required this.id,
    required this.title,
    this.date,
    this.startTime,
    this.endTime,
    this.location,
    this.status,
    required this.order,
  });
}

@immutable
class GetApplicationByIdApplicationShiftOrder {
  final String id;
  final String? eventName;
  final String? location;
  final GetApplicationByIdApplicationShiftOrderBusiness business;
  final GetApplicationByIdApplicationShiftOrderVendor? vendor;
  GetApplicationByIdApplicationShiftOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  eventName = json['eventName'] == null ? null : nativeFromJson<String>(json['eventName']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']),
  business = GetApplicationByIdApplicationShiftOrderBusiness.fromJson(json['business']),
  vendor = json['vendor'] == null ? null : GetApplicationByIdApplicationShiftOrderVendor.fromJson(json['vendor']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdApplicationShiftOrder otherTyped = other as GetApplicationByIdApplicationShiftOrder;
    return id == otherTyped.id && 
    eventName == otherTyped.eventName && 
    location == otherTyped.location && 
    business == otherTyped.business && 
    vendor == otherTyped.vendor;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, eventName.hashCode, location.hashCode, business.hashCode, vendor.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (eventName != null) {
      json['eventName'] = nativeToJson<String?>(eventName);
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    json['business'] = business.toJson();
    if (vendor != null) {
      json['vendor'] = vendor!.toJson();
    }
    return json;
  }

  GetApplicationByIdApplicationShiftOrder({
    required this.id,
    this.eventName,
    this.location,
    required this.business,
    this.vendor,
  });
}

@immutable
class GetApplicationByIdApplicationShiftOrderBusiness {
  final String id;
  final String businessName;
  final String? email;
  final String? contactName;
  GetApplicationByIdApplicationShiftOrderBusiness.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  businessName = nativeFromJson<String>(json['businessName']),
  email = json['email'] == null ? null : nativeFromJson<String>(json['email']),
  contactName = json['contactName'] == null ? null : nativeFromJson<String>(json['contactName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdApplicationShiftOrderBusiness otherTyped = other as GetApplicationByIdApplicationShiftOrderBusiness;
    return id == otherTyped.id && 
    businessName == otherTyped.businessName && 
    email == otherTyped.email && 
    contactName == otherTyped.contactName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, businessName.hashCode, email.hashCode, contactName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['businessName'] = nativeToJson<String>(businessName);
    if (email != null) {
      json['email'] = nativeToJson<String?>(email);
    }
    if (contactName != null) {
      json['contactName'] = nativeToJson<String?>(contactName);
    }
    return json;
  }

  GetApplicationByIdApplicationShiftOrderBusiness({
    required this.id,
    required this.businessName,
    this.email,
    this.contactName,
  });
}

@immutable
class GetApplicationByIdApplicationShiftOrderVendor {
  final String id;
  final String companyName;
  GetApplicationByIdApplicationShiftOrderVendor.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  companyName = nativeFromJson<String>(json['companyName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdApplicationShiftOrderVendor otherTyped = other as GetApplicationByIdApplicationShiftOrderVendor;
    return id == otherTyped.id && 
    companyName == otherTyped.companyName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, companyName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['companyName'] = nativeToJson<String>(companyName);
    return json;
  }

  GetApplicationByIdApplicationShiftOrderVendor({
    required this.id,
    required this.companyName,
  });
}

@immutable
class GetApplicationByIdApplicationShiftRole {
  final String id;
  final String roleId;
  final int count;
  final int? assigned;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final double? hours;
  final double? totalValue;
  final GetApplicationByIdApplicationShiftRoleRole role;
  GetApplicationByIdApplicationShiftRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  roleId = nativeFromJson<String>(json['roleId']),
  count = nativeFromJson<int>(json['count']),
  assigned = json['assigned'] == null ? null : nativeFromJson<int>(json['assigned']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = GetApplicationByIdApplicationShiftRoleRole.fromJson(json['role']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdApplicationShiftRole otherTyped = other as GetApplicationByIdApplicationShiftRole;
    return id == otherTyped.id && 
    roleId == otherTyped.roleId && 
    count == otherTyped.count && 
    assigned == otherTyped.assigned && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    hours == otherTyped.hours && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, roleId.hashCode, count.hashCode, assigned.hashCode, startTime.hashCode, endTime.hashCode, hours.hashCode, totalValue.hashCode, role.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['roleId'] = nativeToJson<String>(roleId);
    json['count'] = nativeToJson<int>(count);
    if (assigned != null) {
      json['assigned'] = nativeToJson<int?>(assigned);
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    return json;
  }

  GetApplicationByIdApplicationShiftRole({
    required this.id,
    required this.roleId,
    required this.count,
    this.assigned,
    this.startTime,
    this.endTime,
    this.hours,
    this.totalValue,
    required this.role,
  });
}

@immutable
class GetApplicationByIdApplicationShiftRoleRole {
  final String id;
  final String name;
  final double costPerHour;
  GetApplicationByIdApplicationShiftRoleRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdApplicationShiftRoleRole otherTyped = other as GetApplicationByIdApplicationShiftRoleRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  GetApplicationByIdApplicationShiftRoleRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class GetApplicationByIdData {
  final GetApplicationByIdApplication? application;
  GetApplicationByIdData.fromJson(dynamic json):
  
  application = json['application'] == null ? null : GetApplicationByIdApplication.fromJson(json['application']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdData otherTyped = other as GetApplicationByIdData;
    return application == otherTyped.application;
    
  }
  @override
  int get hashCode => application.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    if (application != null) {
      json['application'] = application!.toJson();
    }
    return json;
  }

  GetApplicationByIdData({
    this.application,
  });
}

@immutable
class GetApplicationByIdVariables {
  final String id;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  GetApplicationByIdVariables.fromJson(Map<String, dynamic> json):
  
  id = nativeFromJson<String>(json['id']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationByIdVariables otherTyped = other as GetApplicationByIdVariables;
    return id == otherTyped.id;
    
  }
  @override
  int get hashCode => id.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    return json;
  }

  GetApplicationByIdVariables({
    required this.id,
  });
}

